import BigWorld
from Avatar import PlayerAvatar
from string import digits
from gui.Scaleform.daapi.view.meta.CrosshairPanelContainerMeta import CrosshairPanelContainerMeta
from gui.Scaleform.daapi.view.battle.classic.stats_exchange import FragsCollectableStats

from xfw import *
from xvm_main.python.logger import *
import xvm_main.python.config as config
from xfw_actionscript.python import *


VEHICLE_CLASSES = {'mediumTank': 'MT', 'lightTank': 'LT', 'heavyTank': 'HT', 'AT-SPG': 'TD', 'SPG': 'SPG'}

targetDistance = None
targetName = None
targetVehicle = None
targetVType = None
targetColorsVType = None
targetReload = None
targetVisionRadius = None
playerVehicleID = None
f_delayHideTarget = None


@overrideMethod(CrosshairPanelContainerMeta, 'as_setDistanceS')
def CrosshairPanelContainerMeta_as_setDistanceS(base, self, dist):
    if config.get('sight/enabled', True):
        global targetDistance
        i = len(dist) - 1
        while dist[i] not in digits:
            i -= 1
        targetDistance = int(dist[:i+1])


def targetClear():
    global targetName, targetVehicle, targetVType, targetColorsVType, targetReload, targetVisionRadius, targetDistance
    targetDistance = None
    targetName = None
    targetVehicle = None
    targetVType = None
    targetColorsVType = None
    targetReload = None
    targetVisionRadius = None


def delayHideTarget():
    global f_delayHideTarget
    f_delayHideTarget = None
    targetClear()
    as_event('ON_TARGET')


@registerEvent(PlayerAvatar, 'targetBlur')
def PlayerAvatar_targetBlur(self, prevEntity):
    global f_delayHideTarget
    if config.get('sight/enabled', True):
        if prevEntity in self._PlayerAvatar__vehicles:
            delay = config.get('sight/delayHideTarget', 0)
            f_delayHideTarget = BigWorld.callback(delay, delayHideTarget)


@registerEvent(PlayerAvatar, 'targetFocus')
def PlayerAvatar_targetFocus(self, entity):
    global targetName, targetVehicle, targetVType, targetColorsVType, targetReload, targetVisionRadius, targetDistance
    if config.get('sight/enabled', True):
        if entity in self._PlayerAvatar__vehicles:
            if f_delayHideTarget is not None:
                BigWorld.cancelCallback(f_delayHideTarget)
            _type = entity.typeDescriptor.type
            _gun = entity.typeDescriptor.gun
            _miscAttrs = entity.typeDescriptor.miscAttrs
            _turret = entity.typeDescriptor.turret
            crewLevelIncrease = 0.0043 * _miscAttrs.get('crewLevelIncrease', 0)
            targetVehicle = _type.shortUserString
            targetName = entity.publicInfo.name
            targetReload = _gun.reloadTime * _miscAttrs.get('gunReloadTimeFactor', 1) / (1.0695 + crewLevelIncrease)
            targetVisionRadius = _turret.circularVisionRadius * _miscAttrs.get('circularVisionRadiusFactor', 1) * (1.0434 + crewLevelIncrease)
            vehClass = VEHICLE_CLASSES[list(_type.tags.intersection(VEHICLE_CLASSES.keys()))[0]]
            targetVType = config.get('texts/vtype/' + vehClass)
            targetColorsVType = config.get('colors/vtype/' + vehClass)
            as_event('ON_TARGET')


@registerEvent(PlayerAvatar, 'onEnterWorld')
def Vehicle_onEnterWorld(self, prereqs):
    global playerVehicleID
    if config.get('sight/enabled', True):
        playerVehicleID = self.playerVehicleID
        targetClear()


@registerEvent(FragsCollectableStats, 'addVehicleStatusUpdate')
def FragsCollectableStats_addVehicleStatusUpdate(self, vInfoVO):
    if (not vInfoVO.isAlive()) and (playerVehicleID == vInfoVO.vehicleID):
        targetClear()
        as_event('ON_AUTO_AIM')


@xvm.export('sight.nameTarget', deterministic=False)
def sight_targetName():
    return targetName


@xvm.export('sight.vehicleTarget', deterministic=False)
def sight_targetVehicle():
    return targetVehicle


@xvm.export('sight.vtypeTarget', deterministic=False)
def sight_targetVType():
    return targetVType


@xvm.export('sight.c_vtypeTarget', deterministic=False)
def sight_targetColorsVType():
    return targetColorsVType


@xvm.export('sight.reloadTarget', deterministic=False)
def sight_targetReload():
    return targetReload


@xvm.export('sight.visionRadiusTarget', deterministic=False)
def sight_targetVisionRadius():
    return targetVisionRadius


@xvm.export('sight.distanceTarget', deterministic=False)
def sight_targetDistance():
    return targetDistance
